/**
 * @file override oninit function in behavior/mixin
 * @author liujiaor@gmail.com
 */

'use strict';

import {extendInstanceProps} from '../../base/init-api';

/**
 * oninit functions that need to be rewritten
 *
 * @inner
 * @param {Function} parentFunc the parentFunc
 *
 * @return {Function}
 */
export function overrideOninitFunc(parentFunc) {
    return function (...args) {
        this.$query = args[0] || {};
        extendInstanceProps.call(this);
        parentFunc.apply(this, args);
    };
}
