/**
 * @file Make component support broadcast ability
 * @author xieshuqing@baidu.com
 */

'use strict';

import broadcast from '../index';

function callBroadcastCreated() {
    if (this.__isCallBroadcastCreated) {
        return;
    }
    this.__isCallBroadcastCreated = true;
    broadcast.component.created.call(this);
}

export default {
    app: broadcast.app,
    component: Object.assign({}, broadcast.component, {
        onPrefetch: callBroadcastCreated,
        onInit: callBroadcastCreated,
        created: callBroadcastCreated
    })
};
