/**
 * @file Make component support data operation like Vue for swan mini program
 * @author sparklewhy@gmail.com
 */

'use strict';

import observable from '../base';
import initProps from '../initProps';
import proxyArrayApis from '../array';

function callObservableCreated() {
    if (this.__isCallObservableCreated) {
        return;
    }
    this.__isCallObservableCreated = true;
    observable.created.call(this);
}

export default {
    component: Object.assign({}, observable, {
        onPrefetch: callObservableCreated,
        onInit: callObservableCreated,
        created: callObservableCreated,
        __initProps: initProps,
        proxyArrayApis
    })
};
