/**
 * @file Make the store observable
 *       Notice: this plugin should used after the observable plugin if using
 *       computed property
 * @author liujiaor@gmail.com
 */

'use strict';

import vuexBase from '../index';

function callVuexBeforeCreated() {
    if (this.__isCallVuexBeforeCreated) {
        return;
    }
    this.__isCallVuexBeforeCreated = true;
    vuexBase.component.beforeCreate.call(this);
}

export default {
    component: Object.assign({}, vuexBase.component, {
        onPrefetch: callVuexBeforeCreated,
        onInit: callVuexBeforeCreated,
        beforeCreate: callVuexBeforeCreated
    }),
    page: vuexBase.page
};
