/**
 * @file The component base
 * @author liujiaor@gmail.com
 */

'use strict';

import componentBase from '../../base/component';
import EventListener from '../../util/EventListener';
import {extendInstanceProps} from '../../base/init-api';

export default Object.assign({}, componentBase, {

    /**
     * The created hook when component is created
     *
     * @private
     */
    created() {
        extendInstanceProps.call(this);
        this.$listener = new EventListener();
        // call beforeCreate hook
        this.beforeCreate && this.beforeCreate();
    },
    methods: Object.assign({}, componentBase.methods)
});
