/**
 * @file The swan page base
 * @author liujiaor@gmail.com
 */

'use strict';

import component from './component';
import pageBase from '../../base/page';
import {extendInstanceProps} from '../../base/init-api';

function initPage(query) {
    if (this.__isPageInited) {
        return;
    }

    this.__isPageInited = true;
    this.$isPage = true;
    this.$query = query || {};
    extendInstanceProps.call(this);

    /**
     * Create selector query basing global API, this API like the
     * createSelectorQuery defined in the native component context.
     *
     * @return {Object}
     */
    if (!this.createSelectorQuery) {
        this.createSelectorQuery = () => this.$api.createSelectorQuery();
    }
}

export default Object.assign({}, pageBase, component, {
    onPrefetch(options) {
        initPage.call(this, options.query);
    },
    onInit: initPage,
    onLoad(options) {
        initPage.call(this, options);
        // call component create life cycle method
        this.created();
    },
    methods: Object.assign({}, pageBase.methods)
});
